#include "NomadMemory.au3"
#include <File.au3>
#include <Array.au3>


;====PARAMETRES
$winTitle = "Dmineur"
$mSpeed = 0;vitesse de la souris
$space2start = 20 ;en POURCENTAGE, nombre de cases  decouvrir avant de commencer

;thme XP : 22,111
;LSD : 22,105

$startx = 22
$starty = 111

$pix = 16 ;ne devrait pas changer
;==== Fin parametres

;====fonction pause au cas ou le programme plante (boutton PAUSE) - finalement cela quitte le programme
Global $Paused
HotKeySet("{PAUSE}", "TogglePause")
While 1
	

	;==== DEBUT
	;run("winmine.exe")

	WinActivate($winTitle)
	WinWaitActive($winTitle)
	WinMove($winTitle, "", 0, 0)
	Sleep(200)
	
	
	$rst = PixelSearch(0, 0, 500, 120, 0xFFFF00);coordonnes du bouton pour redemarrer le jeu

	;il recupere les infos de jeu (nombre de lignes, de colonnes et de mines) en allant dans la fentre de configuration du mode de jeu "Personnalis..."
	;--A remplacer par une detection de pixel-- (plus tard)
	Send("!p")
	Send("{DOWN}")
	Send("{DOWN}")
	Send("{DOWN}")
	Send("{DOWN}")
	Send("{ENTER}")
	Send("{TAB}")
	Send("{TAB}")
	Send("^c")
	$nb_lignes = ClipGet()
	Send("{TAB}")
	Send("^c")
	$nb_colonnes = ClipGet()
	Send("{TAB}")
	Send("^c")
	$nb_mines = ClipGet()
	Send("{TAB}")
	Send("{TAB}")
	Send("{ENTER}")

	;il remet le mode de jeu prcdent, car sinon le dmineur reste en mode personnalis et donc il n'y a pas de "meilleurs scores"
	If ($nb_lignes = 16 And $nb_colonnes = 30 And $nb_mines = 99) Then ;expert
		Send("!p")
		Send("{DOWN}")
		Send("{DOWN}")
		Send("{DOWN}")
		Send("{ENTER}")
	Else
		If ($nb_lignes = 16 And $nb_colonnes = 16 And $nb_mines = 40) Then ;intermdiaire
			Send("!p")
			Send("{DOWN}")
			Send("{DOWN}")
			Send("{ENTER}")
		Else
			If ($nb_lignes = 9 And $nb_colonnes = 9 And $nb_mines = 10) Then ;Dbutant
				Send("!p")
				Send("{DOWN}")
				Send("{ENTER}")
			EndIf
		EndIf
	EndIf

	;nb de cases  decouvrir pour que le jeu soit gagn :
	$nb_adecouvrir = ($nb_lignes * $nb_colonnes) - $nb_mines


	;Decouvrir les xx% cases avant de commencer :
	$ProcessID = WinGetProcess($winTitle)
	$info = _MemoryOpen($ProcessID)
	$continue = 0
	$bloque = 0

	$decouverts = _MemoryRead(0x010057A4, $info, 'dword')
	$mines = _MemoryRead(0x01005194, $info, 'dword')
	If $decouverts > (($space2start * $nb_lignes * $nb_colonnes) / 100) Then
		ToolTip("Assez de cases decouvertes pour commencer", 0, 0)
		Sleep(200)
		$continue = 1
	EndIf
	While $continue = 0
		$vari_ligne = Random(1, $nb_lignes, 1)
		$vari_coll = Random(1, $nb_colonnes, 1)
		$coord = clic_gauche($vari_ligne, $vari_coll)
		If PixelGetColor($coord[0] - 4, $coord[1] - 5) = "16711680"  Then
			ToolTip("Perdu ! Je recommence", 0, 0)
			MouseClick("left", $rst[0], $rst[1], 1, $mSpeed)
		EndIf
		$decouverts = _MemoryRead(0x010057A4, $info, 'dword')

		If $decouverts > (($space2start * $nb_lignes * $nb_colonnes) / 100) Then
			ToolTip("Assez de cases decouvertes pour commencer", 0, 0)
			Sleep(200)
			ExitLoop
		EndIf
	WEnd
	;fin

	;recuperer le "plan" du jeu (tableau a 2 entres)
	$plan = plan()


	$mines = _MemoryRead(0x01005194, $info, 'dword')

	;boucle principale
	While $mines <> 0 Or $decouverts <> $nb_adecouvrir
		For $nombre = 1 To 6 Step 1
;~ 	ToolTip("Nombre en cours : "& $nombre, 0, 0)
			For $ligne = 0 To $nb_lignes - 1 Step 1
				For $colonne = 0 To $nb_colonnes - 1 Step 1
					$nb_nondecouverte = 0
					$nb_mine = 0
					If ($plan[$ligne][$colonne] = $nombre) Then
						
						$compte = compte_autour($ligne, $colonne)
;~ 		$nb_mine = $compte_autour[0]
;~ 		$nb_nondecouverte = $compte_autour[1]
						;condition pour cliquer sur toutes les cases non decouvertes autour de la case en cours
						If (($compte[1] <> 0) And ($compte[1] + $compte[0] = $nombre)) Then
							For $i1 = -1 To 1 Step 1
								For $i2 = -1 To 1 Step 1
									If (($ligne + $i1 >= 0) And ($colonne + $i2 >= 0) And ($ligne + $i1 <= $nb_lignes - 1) And ($colonne + $i2 <= $nb_colonnes - 1)) Then
										If scan($ligne + 1 + $i1, $colonne + 1 + $i2) = "*"  Then
											clic_droit($ligne + 1 + $i1, $colonne + 1 + $i2)
											clic_autour($ligne + 1 + $i1, $colonne + 1 + $i2)
											$plan = plan()
										EndIf
									EndIf
								Next
							Next
						EndIf
					EndIf
				Next
			Next
		Next
;~ MsgBox(0,"", $decouverts & " , " & $nb_adecouvrir)
		$mines1 = $mines
		$mines = _MemoryRead(0x01005194, $info, 'dword')
		$decouverts = _MemoryRead(0x010057A4, $info, 'dword')

		If $mines1 = $mines Then
			$bloque = bloque($decouverts, $bloque)
			$plan = plan()

			If ($decouverts = _MemoryRead(0x010057A4, $info, 'dword')) Then
				$bloque = $bloque + 1
			EndIf
		EndIf
	WEnd

	Exit

WEnd

;==FIN

Func TogglePause() ;pause ou exit, au choix ..
;~     $Paused = NOT $Paused
;~     While $Paused
;~         sleep(100)
;~         ToolTip('Pause"',0,0)
;~     WEnd
;~     ToolTip("")

	Exit

EndFunc   ;==>TogglePause

Func case_x($colonne)
	$x = $startx + ($colonne - 1) * $pix
	Return $x
EndFunc   ;==>case_x
Func case_y($ligne)
	$y = $starty + ($ligne - 1) * $pix
	Return $y
EndFunc   ;==>case_y
Func clic_droit($ligne, $colonne)
	MouseClick("right", case_x($colonne), case_y($ligne), 1, $mSpeed)
	Dim $avArray
	$avArray = _ArrayCreate(case_x($colonne), case_y($ligne))
	Return $avArray
EndFunc   ;==>clic_droit
Func clic_gauche($ligne, $colonne)
	MouseClick("left", case_x($colonne), case_y($ligne), 1, $mSpeed)
	Dim $avArray
	$avArray = _ArrayCreate(case_x($colonne), case_y($ligne))
	Return $avArray
EndFunc   ;==>clic_gauche
Func clic_molette($ligne, $colonne, $vitesse)
	MouseClick("middle", case_x($colonne), case_y($ligne), 1, $vitesse)
	Dim $avArray
	$avArray = _ArrayCreate(case_x($colonne), case_y($ligne))
	Return $avArray
EndFunc   ;==>clic_molette


;FONCTION SCAN(ligne, colonne) : retourne l'etat de la case  scanner : 1,2,3,4,5,6 pour le nombre , * pour case non decouverte, 0 pour case decouverte sans numero

Func scan($ligne, $colonne)
	$x = case_x($colonne)
	$y = case_y($ligne)
	
	$colortemp = PixelGetColor($x + 1, $y)
	$color = Hex($colortemp)
	If $color = "000000FF"  Then
		Return "1"
	EndIf
	If $color = "00008000"  Then
		Return "2"
	EndIf
	If $color = "00FF0000"  Then
		$colortemp = PixelGetColor($x, $y + 3) ;22,108
		$color = Hex($colortemp)
		If $color = "00000000"  Then
			Return "!" ;cest une mine
		Else
			Return "3" ;cest un 3
		EndIf
	EndIf
	
	If $color = "00000080"  Then
		Return "4"
	EndIf
	If $color = "00800000"  Then
		Return "5"
	EndIf
	If $color = "00008080"  Then
		Return "6"
	EndIf
	If $color = "00C0C0C0"  Then
		$colortemp = PixelGetColor($x, $y - 7)
		$color = Hex($colortemp)
		;22,104 "00FFFFFF"
		If $color = "00FFFFFF"  Then
			Return "*" ;inconnu
		Else
			$colortemp = PixelGetColor($x, $y - 7)
			$color = Hex($colortemp)
			If $color = "00FFFFFF"  Then
				Return "*" ;inconnu
			Else
				Return "0" ;case decouverte
			EndIf
		EndIf
	EndIf
EndFunc   ;==>scan

Func plan() ;cre le plan du jeu  l'aide des fonctions etablies precedemment
	Dim $avArray[$nb_lignes][$nb_colonnes]
	
	For $ligne = 0 To $nb_lignes - 1 Step 1
		For $colonne = 0 To $nb_colonnes - 1 Step 1
			$avArray[$ligne][$colonne] = scan($ligne + 1, $colonne + 1)
		Next
		
	Next
	Return $avArray
EndFunc   ;==>plan


Func compte_autour($ligne, $colonne)
	;0 : nb_mines , 1 : nb_nondecouvertes
	;retourne : nb_nondecouvrtes et nb_mines
	$nb_nondecouverte = 0
	$nb_mine = 0
	Dim $avArray[2]
	For $i1 = -1 To 1 Step 1
		For $i2 = -1 To 1 Step 1
			If (($ligne + $i1 >= 0) And ($colonne + $i2 >= 0) And ($ligne + $i1 <= $nb_lignes - 1) And ($colonne + $i2 <= $nb_colonnes - 1)) Then
				If ($plan[$ligne + $i1][$colonne + $i2] = "*") Then
					$nb_nondecouverte = $nb_nondecouverte + 1
				Else
					If ($plan[$ligne + $i1][$colonne + $i2] = "!") Then
						$nb_mine = $nb_mine + 1
					EndIf
				EndIf
			EndIf
		Next
	Next
	$avArray[0] = $nb_mine
	$avArray[1] = $nb_nondecouverte
	Return $avArray
EndFunc   ;==>compte_autour

Func clic_autour($ligne, $colonne)
	$compte = compte_autour($ligne - 1, $colonne - 1)
	If ($compte[0] <> $nombre Or $compte[1] <> 0) Then
		For $i1 = -1 To 1 Step 1
			For $i2 = -1 To 1 Step 1
				If (($ligne + $i1 >= 1) And ($colonne + $i2 >= 1) And ($ligne + $i1 <= $nb_lignes) And ($colonne + $i2 <= $nb_colonnes)) Then
					$verif = scan($ligne, $colonne + $i2)
					If ($verif <> "*"  And $verif <> "!") Then
						clic_molette($ligne + $i1, $colonne + $i2, $mSpeed)
					EndIf
				EndIf
			Next
		Next
	EndIf
EndFunc   ;==>clic_autour


Func bloque($decouverts, $statut) ;actions  affectuer lorsque le jeu est bloqu (appell depuis la boucle principale)
;~ 	MsgBox(0,"","Le jeu est bloqu")
	;si le jeu est bloqu une premiere fois, on verifie que toutes les cases pouvant tres decouvertes le sont bien
	If $statut = 0 Then
		check()
	Else ;si le jeu est toujours bloqu aprs ca, on avertit l'utilisateur il se charge de decouvrir une ou plusieurs cases
		While (_MemoryRead(0x010057A4, $info, 'dword') = $decouverts)
;~ 		msgbox(0,"","jeu bloqu")
			ToolTip("Le jeu est bloqu, decouvrez une case", 0, 0)
			sleep(1000)
			Return 0
		WEnd
	EndIf

EndFunc   ;==>bloque

;si le jeu est bloqu une premiere fois, on verifie que toutes les cases pouvant tres decouvertes le sont bien
Func check()
	For $nombre = 1 To 6 Step 1
		For $ligne = 0 To $nb_lignes - 1 Step 1
			For $colonne = 0 To $nb_colonnes - 1 Step 1
				$nb_nondecouverte = 0
				$nb_mine = 0
				If ($plan[$ligne][$colonne] = $nombre) Then
					$compte = compte_autour($ligne, $colonne)
					
					If ($compte[0] = $nombre And $compte[1] <> 0) Then
						clic_molette($ligne + 1, $colonne + 1, $mSpeed)
					EndIf
				EndIf
			Next
		Next
	Next
EndFunc   ;==>check